char *help = "\n"
"\n"
" ASC2EBC - Translate an ASCII stream to EBCIDC.\n"
"\n"
" usage:\n"
"       ASC2EBC [{<text_file>}]\n"
" ";

#include <stdio.h>
#include <stdlib.h>

unsigned char table[256] = {

   '\x00','\x01','\x02','\x03','\x37','\x2D','\x2E','\x2F',
/*   NUL    SOH    STX    ETX    EOT    ENQ    ACK    BEL  */
   '\x16','\x05','\x25','\x0B','\x0C','\x0D','\x0E','\x0F',
/*   BS     HT     LF     VT     FF     CR     SO     SI   */
   '\x10','\x11','\x12','\x13','\x3C','\x3D','\x32','\x26',
/*   DEL    DC1    DC2    DC3    DC4    NAK    SYN    ETB  */
   '\x18','\x19','\x3F','\x27','\x22','\x1D','\x1E','\x1F',
/*   CAN    EM     SUB    ESC    FS     GS     RS     US   */
   '\x40','\x5A','\x7F','\x7B','\x5B','\x6C','\x50','\x7D',
/*   SP     !      "      #      $      %      &      '    */
   '\x4D','\x5D','\x5C','\x4E','\x6B','\x60','\x4B','\x61',
/*   (      )      *      +      ,      -      .      /    */
   '\xF0','\xF1','\xF2','\xF3','\xF4','\xF5','\xF6','\xF7',
/*   0      1      2      3      4      5      6      7    */
   '\xF8','\xF9','\x7A','\x5E','\x4C','\x7E','\x6E','\x6F',
/*   8      9      :      ;      <      =      >      ?    */
   '\x7C','\xC1','\xC2','\xC3','\xC4','\xC5','\xC6','\xC7',
/*   @      A      B      C      D      E      F      G    */
   '\xC8','\xC9','\xD1','\xD2','\xD3','\xD4','\xD5','\xD6',
/*   H      I      J      K      L      M      N      O    */
   '\xD7','\xD8','\xD9','\xE2','\xE3','\xE4','\xE5','\xE6',
/*   P      Q      R      S      T      U      V      W    */
   '\xE7','\xE8','\xE9','\xAD','\xE0','\xBD','\x5F','\x6D',
/*   X      Y      Z      [      \      ]      ^      _    */
   '\x7D','\x81','\x82','\x83','\x84','\x85','\x86','\x87',
/*   '      a      b      c      d      e      f      g    */
   '\x88','\x89','\x91','\x92','\x93','\x94','\x95','\x96',
/*   h      i      j      k      l      m      n      o    */
   '\x97','\x98','\x99','\xA2','\xA3','\xA4','\xA5','\xA6',
/*   p      q      r      s      t      u      v      w    */
   '\xA7','\xA8','\xA9','\xC0','\x4F','\xD0','\xA1','\x07',
/*   x      y      z      {      |      }      ~     DEL   */
   '\x40','\x40','\x40','\x40','\x40','\x40','\x40','\x40',
/*         E X T E N D E D   A S C I I  C O D E S          */
   '\x40','\x40','\x40','\x40','\x40','\x40','\x40','\x40',
/*         E X T E N D E D   A S C I I  C O D E S          */
   '\x40','\x40','\x40','\x40','\x40','\x40','\x40','\x40',
/*         E X T E N D E D   A S C I I  C O D E S          */
   '\x40','\x40','\x40','\x40','\x40','\x40','\x40','\x40',
/*         E X T E N D E D   A S C I I  C O D E S          */
   '\x40','\x40','\x40','\x40','\x40','\x40','\x40','\x40',
/*         E X T E N D E D   A S C I I  C O D E S          */
   '\x40','\x40','\x40','\x40','\x40','\x40','\x40','\x40',
/*         E X T E N D E D   A S C I I  C O D E S          */
   '\x40','\x40','\x40','\x40','\x40','\x40','\x40','\x40',
/*         E X T E N D E D   A S C I I  C O D E S          */
   '\x40','\x40','\x40','\x40','\x40','\x40','\x40','\x40',
/*         E X T E N D E D   A S C I I  C O D E S          */
   '\x40','\x40','\x40','\x40','\x40','\x40','\x40','\x40',
/*         E X T E N D E D   A S C I I  C O D E S          */
   '\x40','\x40','\x40','\x40','\x40','\x40','\x40','\x40',
/*         E X T E N D E D   A S C I I  C O D E S          */
   '\x40','\x40','\x40','\x40','\x40','\x40','\x40','\x40',
/*         E X T E N D E D   A S C I I  C O D E S          */
   '\x40','\x40','\x40','\x40','\x40','\x40','\x40','\x40',
/*         E X T E N D E D   A S C I I  C O D E S          */
   '\x40','\x40','\x40','\x40','\x40','\x40','\x40','\x40',
/*         E X T E N D E D   A S C I I  C O D E S          */
   '\x40','\x40','\x40','\x40','\x40','\x40','\x40','\x40',
/*         E X T E N D E D   A S C I I  C O D E S          */
   '\x40','\x40','\x40','\x40','\x40','\x40','\x40','\x40',
/*         E X T E N D E D   A S C I I  C O D E S          */
   '\x40','\x40','\x40','\x40','\x40','\x40','\x40','\x40'
/*         E X T E N D E D   A S C I I  C O D E S          */

};
void  asc2ebc(void);
int   main (int, char *[]);

void  asc2ebc()
{
   char  c;

   while ( (c = (char) getchar() ) != EOF )
      putchar( table[c] );
}




int main (
int   argc,
char *argv[]
)
{
   /* parse command line options */
   while ( --argc > 0  &&  (*++argv)[0] == '-' )
      switch ( (*argv)[1] )  {
      case '?':
      default:
         fprintf( stderr, "%s", help );
         exit( 1 );
      }

   if ( argc > 0 )
      while ( argc-- )  {
         if ( freopen( *argv, "r", stdin ) == NULL )  {
            fprintf( stderr,"ASC2EBC: cannot open '%s'\n", *argv );
            exit( 1 );
         }
         asc2ebc();
         ++argv;
      }
   else
      asc2ebc();

   return( 0 );
}

